#!/bin/sh
# wdimex.sh -- make the message file for iowdm
#
# History:  95/08/29  kmflynn
#
# Usage: wdimex.sh [ file_name ] [| tee output_file ]
# Where: file_name = the name of the message file or test wdm file to build
#                    anmess - to generate the annie message file (default)
#                      test - to generate the wdm file used by graphics test
#                      both - generate both message and test wdm files
#
# Examples:  wdimex.sh
#            wdimex.sh test

# pathnames and directories
  WrdA=/usr/opt/wrdapp
  Libr=$WrdA/libanne4.0

#*******************************************************************
#***** You should not need to modify anything below this line. *****
#*******************************************************************

# files for message file
  Name=iowdms
  SeqMsg='iowdm  inopt  iowdmc  inflat  inflts'
  SeqLib='waide/tbltmp'

  echo
  echo ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ' ; echo
  echo '        building wdm file '                                 ; echo
  echo '              Library =' $Libr
  echo
     echo ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ' ; echo
     echo '             wdm name =' $Name.wdm
     echo '          sequentials =' $SeqMsg
     echo '                       ' $SeqLib
     echo
     echo ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ' ; echo

#    remove any old files
     if [ -f error.fil ] ; then rm error.fil ; fi
     if [ -f $Name.wdm ] ; then rm $Name.wdm ; fi
     if [ -f $Name.in  ] ; then rm $Name.in  ; fi
     if [ -f $Name.err ] ; then rm $Name.err ; fi

#    build input file
     echo $Name.wdm > $Name.in
     for Seq in $SeqMsg ; do
        echo I >> $Name.in
        echo $Seq.seq >> $Name.in
     done
     for Seq in $SeqLib ; do
        echo I >> $Name.in
        echo $Libr/msg/$Seq.seq >> $Name.in
     done
     echo R >> $Name.in

#    get message file shell
     cp $Libr/lib_data/message.wdm $Name.wdm

#    build message file
     $Libr/bin/wdimex < $Name.in

#    remove old message file and move new one
     if [ -f ../bin_data/$Name.wdm ] ; then rm ../bin_data/$Name.wdm ; fi
     mv $Name.wdm ../bin_data
     mv error.fil $Name.err

# end of shell
