C
C
C
      SUBROUTINE   APHELP
     I                   ( MESSFL, SCLU, SGRPI )
C
C     + + + PURPOSE + + +
C     Print general help information to the screen.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, SCLU, SGRPI
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     SCLU   - message file cluster number
C     SGRPI  - initial group number in cluster
C              the first group is a menu containing items with available
C              help, followed by text groups for each menu item.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OPTH, SGRP
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESP, PRNTXT
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize help to first item
      OPTH = 2
 100  CONTINUE
C       help option: 1-return, 2...-application specific
        SGRP = SGRPI
        CALL QRESP ( MESSFL, SCLU, SGRP,
     M               OPTH )
        IF (OPTH .GT. 1) THEN
C         a help item selected, print help
          SGRP = SGRPI + OPTH - 1
          CALL PRNTXT ( MESSFL, SCLU, SGRP )
        END IF
C       if not ready to return, select another help item
      IF (OPTH .GT. 1) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   APINIT
     I                   ( APNAME,
     O                     FE )
C
C     + + + PURPOSE + + +
C     Initialize the application and user environment.  Set application
C     name for window.  Turn off xpad.  Get debugging output level and
C     open error file if needed.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FE
      CHARACTER*16  APNAME
C
C     + + + ARGUMENT DEFINITIONS + + +
C     APNAME - name of application
C     FE     - Fortran unit number of file for debug messages
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   INDEX, OFF
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZANSET, ZSTCMA
C
C     + + + END SPECIFICATIONS + + +
C
C     set application name for window
      CALL ZANSET ( APNAME )
C     turn off Xpad command
      INDEX = 21
      OFF = 0
      CALL ZSTCMA ( INDEX, OFF )
C
C     use error file for warning and error messages
      FE = 99
C
      RETURN
      END
C
C
C
      SUBROUTINE   INSOUR
     I                   ( MESSFL, FE, PTHNAM,
     M                     INFL )
C
C     + + + PURPOSE + + +
C     open a file for input
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, FE, INFL
      CHARACTER*8 PTHNAM(1)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     FE     - Fortran unit number for error file
C     PTHNAM - path to be added to window name
C     INFL   - Fortran unit number of input file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   SCLU, SGRP, LEN, RET
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZWNSOP, QFOPEN
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, LEN
     $     / 105,   1 /
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (1X, 'ERROR INSOUR:  problem opening input file',
     $      /,1x, '               return code =', I8 )
C
C     + + + END SPECIFICATIONS + + +
C
C     open file
      SGRP = 10
      CALL ZWNSOP ( LEN, PTHNAM )
      CALL QFOPEN ( MESSFL, SCLU, SGRP, INFL, RET )
      IF (RET .NE. 0) THEN
C       problem opening file
        INFL = 0
        WRITE (FE,2000) INFL
      END IF
C
      RETURN
      END
