C
C
C
      SUBROUTINE   INWDV
     I                  ( MESSFL, WDMFL, FE,
     M                    INFL, OTFL, DSNS )
C
C     + + + PURPOSE + + +
C     Controls Watstore daily values input processing.  Calls INSOUR
C     to open the file of daily values.  Determines processing options.
C     Calls INWDVX to actually process the daily values file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMFL, FE, INFL, OTFL, DSNS(3)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMFL  - Fortran unit number of wdm file
C     FE     - Fortran unit number for debugging output (0 if none)
C     INFL   - Fortran unit number of input file
C     OTFL   - Fortran unit number for summary outptut file
C              if summary not requested, 0
C     DSNS   - data set information array
C              (1) data set number to be added next
C              (2) increment between types of data
C              (3) increment between stations
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OPT, SCLU, SGRP, DSOPT(3), RTCMND,
     $          LPTH, KEEP, VERS, SPACE(5), TIME(7), DUMI(2), INOP
      CHARACTER*8 PTHNAM(2)
C
C     + + + EXTERNALS + + +
      EXTERNAL   INSOUR, INOPTN, INITAT, INWDVX
      EXTERNAL   ZWNSOP, PRNTXT, QFCLOS, QRESP
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, PTHNAM
     $     / 103, 'Daily   ', 'D       ' /
      DATA  SPACE,           TIME
     $    / 40,75,150,1,1,   4,6,1,1,1,1900,1 /
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize attribute arrays
      VERS = 1
      CALL INITAT ( VERS, SPACE, TIME )
C     default confirm=first, status=new
      DSOPT(1) = 2
      DSOPT(2) = 1
C
C     default to start with source
      OPT = 1
 10   CONTINUE
C       option: 1-source,2-options,3-process,4-return
        SGRP = 1
        LPTH = 2
        CALL ZWNSOP ( LPTH, PTHNAM )
        CALL QRESP ( MESSFL, SCLU, SGRP, OPT )
        IF (OPT .EQ. 1) THEN
C         open source file
          CALL INSOUR ( MESSFL, FE, PTHNAM(2), INFL )
C         now default opt to options
          OPT = 2
        ELSE IF (OPT .EQ. 2) THEN
C         modify options
          LPTH = 1
          INOP = 1
          CALL INOPTN ( MESSFL, LPTH, PTHNAM(2), INOP,
     M                  DSOPT, DSNS, DUMI,
     O                  RTCMND )
C         now default opt to process
          OPT = 3
        ELSE IF (OPT .EQ. 3) THEN
C         process the input file
          IF (INFL .EQ. 0) THEN
C           input file is not open
            SGRP = 5
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default option to source
            OPT = 1
          ELSE
C           process the input file
            LPTH = 1
            CALL INWDVX ( MESSFL, WDMFL, FE, INFL, OTFL,
     I                    DSOPT(2), DSOPT(1), DSNS(2), LPTH, PTHNAM(2),
     M                    DSNS(1) )
C           close input file
            KEEP = 0
            CALL QFCLOS ( INFL, KEEP )
            INFL = 0
C           now default opt to source
            OPT = 1
          END IF
        END IF
C       select another option if not ready to return
      IF (OPT .LT. 4) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   INWUV
     I                  ( MESSFL, WDMFL, FE,
     M                    INFL, OTFL, DSNS )
C
C     + + + PURPOSE + + +
C     Controls Watstore unit values input processing.  Calls INSOUR
C     to open the file of unit values.  Determines processing options.
C     Calls INWUVX to actually process the unit values file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMFL, FE, INFL, OTFL, DSNS(3)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMFL  - Fortran unit number of wdm file
C     FE     - Fortran unit number for debugging output (0 if none)
C     INFL   - Fortran unit number of input file
C     OTFL   - Fortran unit number for summary outptut file
C              if summary not requested, 0
C     DSNS   - data set information array
C              (1) data set number to be added next
C              (2) increment between types of data
C              (3) increment between stations
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OPT, SCLU, SGRP, DSOPT(3), RTCMND,
     $          LPTH, KEEP, VERS, SPACE(5), TIME(7), INOP, DUMI(2)
      CHARACTER*8 PTHNAM(2)
C
C     + + + EXTERNALS + + +
      EXTERNAL   INSOUR, INOPTN, INITAT, INWUVX
      EXTERNAL   ZWNSOP, PRNTXT, QFCLOS, QRESP
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, PTHNAM
     $     / 103, 'Unit    ', 'U       ' /
      DATA  SPACE,           TIME
     $    / 40,75,150,1,1,   2,5,1,1,1,1900,5 /
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize attribute arrays
      VERS = 1
      CALL INITAT ( VERS, SPACE, TIME )
C     default confirm=first, status=new
      DSOPT(1) = 2
      DSOPT(2) = 1
C
C     default to start with source
      OPT = 1
 10   CONTINUE
C       option: 1-source,2-options,3-process,4-return
        SGRP = 1
        LPTH = 2
        CALL ZWNSOP ( LPTH, PTHNAM )
        CALL QRESP ( MESSFL, SCLU, SGRP, OPT )
        IF (OPT .EQ. 1) THEN
C         open source file
          CALL INSOUR ( MESSFL, FE, PTHNAM(2), INFL )
C         now default opt to options
          OPT = 2
        ELSE IF (OPT .EQ. 2) THEN
C         modify options
          LPTH = 1
          INOP = 1
          CALL INOPTN ( MESSFL, LPTH, PTHNAM(2), INOP,
     M                  DSOPT, DSNS, DUMI,
     O                  RTCMND )
C         now default opt to process
          OPT = 3
        ELSE IF (OPT .EQ. 3) THEN
C         process the input file
          IF (INFL .EQ. 0) THEN
C           input file is not open
            SGRP = 5
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default option to source
            OPT = 1
          ELSE
C           process the input file
            LPTH = 1
            CALL INWUVX ( MESSFL, WDMFL, FE, INFL, OTFL,
     I                    DSOPT(2), DSOPT(1), DSNS(2), LPTH, PTHNAM(2),
     M                    DSNS(1) )
C           close input file
            KEEP = 0
            CALL QFCLOS ( INFL, KEEP )
            INFL = 0
C           now default opt to source
            OPT = 1
          END IF
        END IF
C       select another option if not ready to return
      IF (OPT .LT. 4) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   INWBC
     I                  ( MESSFL, WDMFL, FE,
     M                    INFL, OTFL, DSNS )
C
C     + + + PURPOSE + + +
C     Controls Watstore basin characteristics input processing.  Calls
C     INSOUR to open the file of unit values.  Determines processing
C     options.  Calls INWBCX to actually process the unit values file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMFL, FE, INFL, OTFL, DSNS(3)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMFL  - Fortran unit number of wdm file
C     FE     - Fortran unit number for debugging output (0 if none)
C     INFL   - Fortran unit number of input file
C     OTFL   - Fortran unit number for summary outptut file
C              if summary not requested, 0
C     DSNS   - data set information array
C              (1) data set number to be added next
C              (2) increment between types of data
C              (3) increment between stations
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OPT, SCLU, SGRP, DSOPT(3), INOP, DUMI(2),
     $          RTCMND, LPTH, KEEP, ABNDX(200), VERS, SPACE(5), TIME(7)
      CHARACTER*1 ABNAME(6,200)
      CHARACTER*8 PTHNAM(2)
C
C     + + + EXTERNALS + + +
      EXTERNAL   INSOUR, INOPTN, INWBCX, INITAT, INITBC
      EXTERNAL   ZWNSOP, PRNTXT, QFCLOS, QRESP
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, PTHNAM
     $     / 103, 'Basin   ', 'B       ' /
      DATA  SPACE,           TIME
     $    / 100,120,10,1,1,  6,7,1,1,1,1800,1 /
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize attribute values arrays to defaults
      VERS = 2
      CALL INITAT ( VERS, SPACE, TIME )
      CALL INITBC ( MESSFL, ABNDX, ABNAME )
C
C     default confirm=first, status=new, type=time
      DSOPT(1) = 2
      DSOPT(2) = 1
      DSOPT(3) = 1
C
C     default to start with source
      OPT = 1
 10   CONTINUE
C       option: 1-source,2-options,3-process,4-return
        SGRP = 1
        LPTH = 2
        CALL ZWNSOP ( LPTH, PTHNAM )
        CALL QRESP ( MESSFL, SCLU, SGRP, OPT )
        IF (OPT .EQ. 1) THEN
C         open source file
          CALL INSOUR ( MESSFL, FE, PTHNAM(2), INFL )
C         now set default to option
          OPT = 2
        ELSE IF (OPT .EQ. 2) THEN
C         modify options
          LPTH = 1
          INOP = 3
          CALL INOPTN ( MESSFL, LPTH, PTHNAM(2), INOP,
     M                  DSOPT, DSNS, DUMI,
     O                  RTCMND )
C         now set default to process
          OPT = 3
        ELSE IF (OPT .EQ. 3  .AND.  INFL .EQ. 0) THEN
C         can't process the input file till it is opened
          SGRP = 5
          CALL PRNTXT ( MESSFL, SCLU, SGRP )
C         default option to source
          OPT = 1
        ELSE IF (OPT .EQ. 3) THEN
C         process the input file
          LPTH = 1
          CALL INWBCX ( MESSFL, WDMFL, FE, INFL, OTFL,
     I                  DSOPT(2), DSOPT(1), DSOPT(3), DSNS(2),
     I                  LPTH, PTHNAM(2), ABNDX, ABNAME,
     M                  DSNS(1) )
C         close input file
          KEEP = 0
          CALL QFCLOS ( INFL, KEEP )
          INFL = 0
C         now set default to source for another file
          OPT = 1
        END IF
C       select another option if not ready to return
      IF (OPT .LT. 4) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   INWPK
     I                  ( MESSFL, WDMFL, FE,
     M                    INFL, OTFL, DSNS )
C
C     + + + PURPOSE + + +
C     Controls Watstore peak values input processing.  Calls INSOUR
C     to open the file of peak flows.  Determines processing options.
C     Calls INWPKX to actually process the peak values file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMFL, FE, INFL, OTFL, DSNS(3)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMFL  - Fortran unit number of wdm file
C     FE     - Fortran unit number for debugging output (0 if none)
C     INFL   - Fortran unit number of input file
C     OTFL   - Fortran unit number for summary outptut file
C              if summary not requested, 0
C     DSNS   - data set information array
C              (1) data set number to be added next
C              (2) increment between types of data
C              (3) increment between stations
C
C       + + + LOCAL VARIABLES + + +
      INTEGER   OPT, SCLU, SGRP, 
     $          DSOPT(3), CALND(2), RTC, INOP,
     $          LPTH, KEEP, VERS, SPACE(5), TIME(7)
      CHARACTER*8 PTHNAM(2)
C
C       + + + EXTERNALS + + +
      EXTERNAL   INSOUR, INITAT, INWPKX, INOPTN
      EXTERNAL   ZWNSOP, PRNTXT, QFCLOS, QRESP
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, PTHNAM
     $     / 103, 'Peak    ', 'P       ' /
      DATA  SPACE,           TIME
     $    / 100,120,10,1,1,  6,7,1,1,1,1800,1 /
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize attribute arrays
      VERS = 1
      CALL INITAT ( VERS, SPACE, TIME )
C
C     default: confirm=first,status=new,type=table,calendar=water year
      DSOPT(1) = 2
      DSOPT(2) = 1
      DSOPT(3) = 2
      CALND(1) = 10
      CALND(2) = 9
C
C     default to start with source
      OPT = 1
 100  CONTINUE
C       option: 1-source,2-options,3-process,4-return
        SGRP = 1
        LPTH = 2
        CALL ZWNSOP ( LPTH, PTHNAM )
        CALL QRESP ( MESSFL, SCLU, SGRP, OPT )
        IF (OPT .EQ. 1) THEN
C         open source file
          CALL INSOUR ( MESSFL, FE, PTHNAM(2), INFL )
C         now default opt to options
          OPT = 2
        ELSE IF (OPT .EQ. 2) THEN
C         get options
          LPTH = 1
          INOP = 2
          CALL INOPTN ( MESSFL, LPTH, PTHNAM(2), INOP,
     M                  DSOPT, DSNS, CALND,
     O                  RTC )
C         now default opt to process
          OPT = 3
        ELSE IF (OPT .EQ. 3) THEN
C         process the input file
          IF (INFL .EQ. 0) THEN
C           input file is not open
            SGRP = 5
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default option to source
            OPT = 1
          ELSE
C           process the input file
            LPTH = 1
            CALL INWPKX ( MESSFL, WDMFL, FE, INFL, OTFL, LPTH,
     I                    PTHNAM(2), DSOPT(2), DSOPT(1), DSOPT(3),
     I                    CALND, DSNS(2),
     M                    DSNS(1) )
C           close input file
            KEEP = 0
            CALL QFCLOS ( INFL, KEEP )
            INFL = 0
C           now default opt to source
            OPT = 1
          END IF
        END IF
C       select another option if not ready to return
      IF (OPT .LT. 4) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   INWHL
     I                  ( MESSFL, WDMFL, FE,
     M                    INFL, OTFL, DSNS )
C
C     + + + PURPOSE + + +
C     Controls Watstore n-day high and/or low flow values input
C     processing.  Calls INSOUR to open the input file.  Determines
C     processing options.  Calls INWHLX to process the input file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMFL, FE, INFL, OTFL, DSNS(3)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMFL  - Fortran unit number of wdm file
C     FE     - Fortran unit number for debugging output (0 if none)
C     INFL   - Fortran unit number of input file
C     OTFL   - Fortran unit number for summary outptut file
C              if summary not requested, 0
C     DSNS   - data set information array
C              (1) data set number to be added next
C              (2) increment between types of data
C              (3) increment between stations
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OPT, SCLU, SGRP, DSOPT(3), RTCMND,
     $          LPTH, KEEP, VERS, SPACE(5), TIME(7), INOP, DUMI(2)
      CHARACTER*8 PTHNAM(2)
C
C     + + + EXTERNALS + + +
      EXTERNAL   INSOUR, INOPTN, INITAT, INWHLX
      EXTERNAL   ZWNSOP, PRNTXT, QFCLOS, QRESP
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, PTHNAM
     $     / 103, 'N-Day   ', 'N       ' /
      DATA  SPACE,           TIME
     $    / 100,120,10,1,1,  6,7,1,1,1,1800,1 /
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize attribute arrays
      VERS = 3
      CALL INITAT ( VERS, SPACE, TIME )
C     default confirm=first, status=new
      DSOPT(1) = 2
      DSOPT(2) = 1
C
C     default to start with source
      OPT = 1
 10   CONTINUE
C       option: 1-source,2-options,3-process,4-return
        SGRP = 1
        LPTH = 2
        CALL ZWNSOP ( LPTH, PTHNAM )
        CALL QRESP ( MESSFL, SCLU, SGRP, OPT )
        IF (OPT .EQ. 1) THEN
C         open source file
          CALL INSOUR ( MESSFL, FE, PTHNAM(2), INFL )
C         now default opt to options
          OPT = 2
        ELSE IF (OPT .EQ. 2) THEN
C         modify options
          LPTH = 1
          INOP = 4
          CALL INOPTN ( MESSFL, LPTH, PTHNAM(2), INOP,
     M                  DSOPT, DSNS, DUMI,
     O                  RTCMND )
C         now default opt to process
          OPT = 3
        ELSE IF (OPT .EQ. 3) THEN
C         process the input file
          IF (INFL .EQ. 0) THEN
C           input file is not open
            SGRP = 5
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default option to source
            OPT = 1
          ELSE
C           process the input file
            LPTH = 1
            CALL INWHLX ( MESSFL, WDMFL, FE, INFL, OTFL,
     I                    DSOPT(2), DSOPT(1), DSNS(2), LPTH, PTHNAM(2),
     M                    DSNS(1) )
C           close input file
            KEEP = 0
            CALL QFCLOS ( INFL, KEEP )
            INFL = 0
C           now default opt to source
            OPT = 1
          END IF
        END IF
C       select another option if not ready to return
      IF (OPT .LT. 4) GO TO 10
C
      RETURN
      END
