C
C
C
      PROGRAM   IOWDM
C
C     + + + PURPOSE + + +
C     This program is used to enter data into or retrieve data from
C     a WDM file.  Allowable input data formats are selected WATSTORE
C     Carter, and flat.  Output is to selected WATSTORE and flat file
C     formats.
C
C     + + + PARAMETERS + + +
      INCLUDE 'pmesfl.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       FE, SCLU, SGRP, OPT, WDMFL, INFL, OTFL, RETC, I1
      CHARACTER*8   PTHNAM, APNAME
      CHARACTER*16  WNAME
      CHARACTER*64  FNAME, VERSN
C
C     + + + LOCAL DEFINITIONS + + +
C     FE     - Fortran unit number for debug output, 0 if none
C     INFL   - Fortran unit number for input data file
C     OTFL   - Fortran unit number for output summary file
C     WDMFL  - Fortran unit number for WDM file
C
C     + + + EXTERNALS + + +
      EXTERNAL   APINIT, APHELP, INWDM,  INWIOX
      EXTERNAL   ANINIZ, PRWFIL, WDFLCL, ANCLOS, QRESP, PRNTXT
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, WDMFL, INFL, OTFL, I1
     $     / 105,     0,    0,    0,  1 /
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (//, ' *** ERROR',
     $         /, ' *** ERROR',
     $         /, ' *** ERROR  Problem closing wdm data file',
     $         /, ' *** ERROR          Return code =', I6,
     $         /, ' *** ERROR',
     $         /, ' *** ERROR' )
C
C     + + + END SPECIFICATIONS + + +
C
C     initialize user environment
C     version info for unix what
C     names of application, log file, and message file
      INCLUDE 'fiowdm.inc'
C
C     open message file and log file
      CALL ANINIZ ( MESSFL, FNAME, APNAME )
C
C     set application name
      CALL APINIT ( WNAME,
     O              FE )
C
C     call routine to set interactive flag in common
      CALL INWIOX (I1)
C
C     default is to start by opening the wdm file
      OPT = 1
 10   CONTINUE
C       opening screen: 1-file,2-input,3-output,4-help,5-query,6-return
        SGRP = 1
        CALL QRESP ( MESSFL, SCLU, SGRP,
     M               OPT )
        GO TO ( 100, 200, 300, 400, 800, 900 ), OPT
 100    CONTINUE
C         manage wdm file, set path name
          PTHNAM = '        '
          CALL PRWFIL ( MESSFL, PTHNAM,
     M                  WDMFL )
          GO TO 900
 200    CONTINUE
C         input new data to wdm file
          IF (WDMFL .GT. 0) THEN
C           input new data
            CALL INWDM ( MESSFL, WDMFL, FE,
     M                   INFL, OTFL )
          ELSE
C           wdm file not open, must be open to input data
            SGRP = 3
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default OPTion to file
            OPT = 1
          END IF
          GO TO 900
 300    CONTINUE
C         output data from wdm file
          IF (WDMFL .GT. 0) THEN
C           output data
C           not yet available
            SGRP = 5
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default option to input
            OPT = 2
          ELSE
C           wdm file not open
            SGRP = 4
            CALL PRNTXT ( MESSFL, SCLU, SGRP )
C           default option to file
            OPT = 1
          END IF
          GO TO 900
 400    CONTINUE
C         help information
          SGRP = 20
          CALL APHELP ( MESSFL, SCLU, SGRP )
C         default OPTion to file
          OPT = 1
          GO TO 900
 800    CONTINUE
C         query support contact
          SGRP = 2
          CALL PRNTXT ( MESSFL, SCLU, SGRP )
          OPT = 1
          GO TO 900
 900    CONTINUE
C       get next option if not ready to return to system
      IF (OPT .LT. 6) GO TO 10
C
C     shut down aide
      CALL ANCLOS ( MESSFL )
C
C     close any files left open
      IF (WDMFL .GT. 0) THEN
C       close wdm file
        CALL WDFLCL ( WDMFL, RETC )
        IF (RETC .NE. 0) THEN
C         problem closing wdm file
          WRITE(99,2000) RETC
          WRITE (*,2000) RETC
        END IF
      END IF
      IF (INFL .GT. 0) THEN
C       close input file
        CLOSE ( INFL )
      END IF
      IF (OTFL .GT. 0) THEN
C       close output file
        CLOSE ( OTFL )
      END IF
      IF (FE .GT. 0) THEN
C       close error file
        CLOSE ( FE )
      END IF
C
      STOP
      END
C
C
C
      SUBROUTINE   INWDM
     I                  ( MESSFL, WDMFL, FERR,
     M                    INFL, OTFL )
C
C     + + + PURPOSE + + +
C     Select input format and call appropriate routine to process
C     the data.  Will also allow you to look at the contents of a
C     data file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL, WDMFL, FERR, INFL, OTFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of the message file
C     WDMFL  - Fortran unit number of the wdm file
C     FERR   - Fortran unit number for the error/debug output
C     INFL   - Fortran unit number of input file
C     OTFL   - Fortran unit number of summary output file
C              if 0, summary output to error.fil file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   OPTIN, SCLU, SGRP, DSNS(3), SGRP1, SGRP2, FE
C
C     + + + EXTERNALS + + +
      EXTERNAL   INWDV, INWUV, INWBC, INWPK, INWHL, INFLTS, INFLAT
      EXTERNAL   QRESP, REOPEN
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  SCLU, DSNS
     $     / 105, 1,1,1 /
C
C     + + + END SPECIFICATIONS
C
      IF (OTFL .EQ. 0) THEN
C       send summary output to error.fil file
        FE = FERR
      ELSE
C       send summary and errors to summary file
        FE = OTFL
      END IF
C     default input option is watstore daily values
      OPTIN = 9
 10   CONTINUE
C          other: 1-return,9-open output
C       watstore: 2-daily,3-unit,4-basin,5-peak,6-n-day
C           flat: 7-timeseries,8-attributes
        SGRP = 51
        CALL QRESP ( MESSFL, SCLU, SGRP, OPTIN )
        IF (OPTIN .GE. 2  .AND.  OPTIN .LE. 6) THEN
C         input watstore card-image format
          IF (OPTIN .EQ. 2) THEN
C           watstore daily values card image format
            CALL INWDV ( MESSFL, WDMFL, FE,
     M                   INFL, OTFL, DSNS )
          ELSE IF (OPTIN .EQ. 3) THEN
C           watstore unit values card image format
            CALL INWUV( MESSFL, WDMFL, FE,
     M                   INFL, OTFL, DSNS )
          ELSE IF (OPTIN .EQ. 4) THEN
C           watstore basin characteristics
            CALL INWBC ( MESSFL, WDMFL, FE,
     M                   INFL, OTFL, DSNS )
          ELSE IF (OPTIN .EQ. 5) THEN
C           watstore annual peak flows card-image format
            CALL INWPK ( MESSFL, WDMFL, FE,
     M                   INFL, OTFL, DSNS )
          ELSE IF (OPTIN .EQ. 6) THEN
C           watstore n-day high/low flow card-image format
            CALL INWHL ( MESSFL, WDMFL, FE,
     M                   INFL, OTFL, DSNS )
          END IF
        ELSE IF ( OPTIN .EQ. 7) THEN
C         flat file timeseries
          CALL INFLTS ( MESSFL, WDMFL, FE )
        ELSE IF (OPTIN .EQ. 8) THEN
C         flat file attributes
          CALL INFLAT ( MESSFL, WDMFL, FE )
        ELSE IF (OPTIN .EQ. 9) THEN
C         open summary output file
          SGRP1 = 11
          SGRP2 = 12
          CALL REOPEN ( MESSFL, SCLU, SGRP1, SGRP2, OTFL )
          FE = OTFL
          OPTIN = 7
        END IF
C       select another input option if not ready to return
      IF (OPTIN .NE. 1) GO TO 10
C
      RETURN
      END
